image: timbru31/node-chrome:latest

stages:
  - build
  - deploy

build-always:
  stage: build
  except:
    - main
  artifacts:
    paths:
      - dist/
  cache:
    paths:
      - node_modules/
  script:
    - npm install --loglevel=error --no-progress
    - npm run ngcc # Run npm-script ngcc, if ng build does it, the ci breaks sometimes (not enough memory)
    - npm run build
    - cd dist/
    - ls -al

build-demo:
  stage: build
  only:
    - develop
  artifacts:
    paths:
      - dist/
  cache:
    paths:
      - node_modules/
  script:
    - npm install --loglevel=error --no-progress
    - npm run ngcc # Run npm-script ngcc, if ng build does it, the ci breaks sometimes (not enough memory)
    - npm run build:demo
    - cd dist/
    - ls -al

#test:
#  stage: build
#  except:
#    - main
#  only:
#    - branches
#  dependencies: []
#  artifacts:
#    paths:
#      - coverage/
#  cache:
#    paths:
#      - node_modules/
#  allow_failure: true
#  script:
##    - wget -q -O - https://dl-ssl.google.com/linux/linux_signing_key.pub | apt-key add -
##    - sh -c 'echo "deb [arch=amd64] http://dl.google.com/linux/chrome/deb/ stable main" >> /etc/apt/sources.list.d/google.list'
##    - apt-get update -qq && apt-get install -y -qq google-chrome-stable >> /dev/null
##    - export CHROME_BIN=/usr/bin/google-chrome
#    - npm install --loglevel=error --no-progress
#    - npm run ngcc # Run npm-script ngcc, if ng build does it, the ci breaks sometimes (not enough memory)
#    - npm run test:ci

deploy-dev:
  stage: deploy
  dependencies:
    - build-always
  only:
    - develop
  cache: {}
  script:
    - apt-get update -qq && apt-get install -y -qq zip openssh-client >> /dev/null
    - eval "$(ssh-agent -s)"
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh && chmod 700 ~/.ssh
    - cd dist/
    - zip -r dfx-bootstrap-table-dev.zip ./dfx-bootstrap-table >> /dev/null
    - scp -P $SSH_PORT -o StrictHostKeyChecking=no -o LogLevel=ERROR ./dfx-bootstrap-table-dev.zip $SSH_USERNAME@$SSH_HOST:/var/www/datepoll-share/common/dfx-bootstrap-table/ > /dev/null

deploy-demo:
  stage: deploy
  dependencies:
    - build-demo
  only:
    - develop
  cache: {}
  script:
    - apt-get update -qq && apt-get install -y -qq zip openssh-client >> /dev/null
    - eval "$(ssh-agent -s)"
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - echo "$SSH_TESTING_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh && chmod 700 ~/.ssh
    - cd dist/
    - zip -r dfx-bootstrap-table-demo.zip ./dfx-bootstrap-table-demo >> /dev/null
    - scp -P $SSH_PORT -o StrictHostKeyChecking=no -o LogLevel=ERROR ./dfx-bootstrap-table-demo.zip $SSH_USERNAME@$SSH_HOST:/var/www/datepoll-share/common/dfx-bootstrap-table/ > /dev/null
    - scp -P $SSH_TESTING_PORT -o StrictHostKeyChecking=no -rp ./dfx-bootstrap-table-demo/* $SSH_TESTING_USERNAME@$SSH_TESTING_HOST:/var/www/dfx-bootstrap-table-demo > /dev/null

deploy-release-zip:
  stage: deploy
  dependencies:
    - build-always
  only:
    - tags
  except:
    - branches
  cache: {}
  allow_failure: true
  script:
    - apt-get update -qq && apt-get install -y -qq zip git openssh-client >> /dev/null
    - eval "$(ssh-agent -s)"
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh && chmod 700 ~/.ssh
    - version=$(git describe --tags $(git rev-list --tags --max-count=1))
    - cd dist/
    - zip -r "dfx-bootstrap-table-${version}.zip" ./dfx-bootstrap-table >> /dev/null
    - cp "dfx-bootstrap-table-${version}.zip" dfx-bootstrap-table-latest.zip
    - scp -P $SSH_PORT -o StrictHostKeyChecking=no -o LogLevel=ERROR ./dfx-bootstrap-table-latest.zip $SSH_USERNAME@$SSH_HOST:/var/www/datepoll-share/common/dfx-bootstrap-table/ > /dev/null
    - scp -P $SSH_PORT -o StrictHostKeyChecking=no -o LogLevel=ERROR "dfx-bootstrap-table-${version}.zip" $SSH_USERNAME@$SSH_HOST:/var/www/datepoll-share/common/dfx-bootstrap-table/ > /dev/null

deploy-release-npm:
  stage: deploy
  dependencies:
    - build-always
  only:
    - tags
  except:
    - branches
  cache: {}
  script:
    - cd dist/dfx-bootstrap-table/
    - npm config set //registry.npmjs.org/:_authToken ${NPM_PUBLISH_TOKEN}
    - npm publish
